#import "NX_Button.h"

@implementation NX_Button

- (void) drawRect:(NSRect) inRect
{
	NSRect tBounds;
	NSImage * tImage;
	NSSize tSize;
	
	tBounds=[self bounds];

	if ([[self cell] isHighlighted]==YES)
	{
		[[NSColor whiteColor] set];
		
		NSRectFill(tBounds);
		
		[[NSColor blackColor] set];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(0.5f,NSMinY(tBounds)+1.0f) toPoint:NSMakePoint(0.5,NSMaxY(tBounds)-0.5f)];
			
		[NSBezierPath strokeLineFromPoint:NSMakePoint(0.0f,NSMinY(tBounds)+0.5f) toPoint:NSMakePoint(NSMaxX(tBounds)-1.0f,NSMinY(tBounds)+0.5)];
		
		[[NSColor colorWithDeviceWhite:0.666f alpha:1.0f] set];
	
		[NSBezierPath strokeLineFromPoint:NSMakePoint(NSMaxX(tBounds)-0.5f,NSMinY(tBounds)) toPoint:NSMakePoint(NSMaxX(tBounds)-0.5f,NSMaxY(tBounds))];
			
		[NSBezierPath strokeLineFromPoint:NSMakePoint(0.0f,NSMaxY(tBounds)-0.5f) toPoint:NSMakePoint(NSMaxX(tBounds),NSMaxY(tBounds)-0.5)];
	}
	else
	{
		[[NSColor colorWithDeviceWhite:0.666f alpha:1.0f] set];
		
		NSRectFill(tBounds);
		
		[[NSColor whiteColor] set];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(0.5f,NSMinY(tBounds)+1.0f) toPoint:NSMakePoint(0.5,NSMaxY(tBounds)-0.5f)];
			
		[NSBezierPath strokeLineFromPoint:NSMakePoint(0.0f,NSMinY(tBounds)+0.5f) toPoint:NSMakePoint(NSMaxX(tBounds)-1.0f,NSMinY(tBounds)+0.5)];
		
		[[NSColor blackColor] set];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(NSMaxX(tBounds)-0.5f,NSMinY(tBounds)) toPoint:NSMakePoint(NSMaxX(tBounds)-0.5f,NSMaxY(tBounds))];
			
		[NSBezierPath strokeLineFromPoint:NSMakePoint(0.0f,NSMaxY(tBounds)-0.5f) toPoint:NSMakePoint(NSMaxX(tBounds),NSMaxY(tBounds)-0.5)];

		[[NSColor colorWithDeviceWhite:0.333f alpha:1.0f] set];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(NSMaxX(tBounds),NSMinY(tBounds)+0.5f) toPoint:NSMakePoint(NSMaxX(tBounds)-1.0f,NSMinY(tBounds)+0.5f)];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(NSMinX(tBounds),NSMaxY(tBounds)-0.5f) toPoint:NSMakePoint(NSMinX(tBounds)+1.0f,NSMaxY(tBounds)-0.5f)];
		
		[NSBezierPath strokeLineFromPoint:NSMakePoint(NSMaxX(tBounds)-1.5f,NSMinY(tBounds)+1.0f) toPoint:NSMakePoint(NSMaxX(tBounds)-1.5f,NSMaxY(tBounds)-1.0f)];
			
		[NSBezierPath strokeLineFromPoint:NSMakePoint(1.0f,NSMaxY(tBounds)-1.5f) toPoint:NSMakePoint(NSMaxX(tBounds)-1,NSMaxY(tBounds)-1.5)];
	}
	
	tImage=[self image];
	
	tSize=[tImage size];
	
	[tImage setFlipped:YES];
	
	if ([[self cell] isHighlighted]==YES)
	{
		[tImage drawInRect:NSMakeRect(roundf(NSMidX(tBounds)-0.5f*tSize.width),roundf(NSMidY(tBounds)-0.5f*tSize.height),tSize.width,tSize.height) fromRect:NSMakeRect(0,0,tSize.width,tSize.height) operation:NSCompositeSourceOver fraction:1.0f];
	}
	else
	{
		[tImage drawInRect:NSMakeRect(roundf(NSMidX(tBounds)-0.5f*tSize.width)-1.0f,roundf(NSMidY(tBounds)-0.5f*tSize.height)-1.0f,tSize.width,tSize.height) fromRect:NSMakeRect(0,0,tSize.width,tSize.height) operation:NSCompositeSourceOver fraction:1.0f];
	}
}

@end
