#import <Cocoa/Cocoa.h>

#define NX_InteractionMode_None			0
#define NX_InteractionMode_Drag			1
#define NX_InteractionMode_ResizeLeft	2
#define NX_InteractionMode_ResizeRight	3

@interface NX_WindowThemeFrame : NSView
{
	int interactionMode_;
	
	NSRect titleBar_;

	NSRect leftResizeIndicator_;
	
	NSRect rightResizeIndicator_;
	
	BOOL isKey_;
}

- (void) setIsKey:(BOOL) aBool;

@end


@interface NX_Window : NSWindow
{
	IBOutlet id IBcloseButton_;
	
	IBOutlet id IBminiaturizeButton_;
}

- (IBAction) close:(id) sender;

@end
