#import <Cocoa/Cocoa.h>

@interface MainController : NSObject
{
	IBOutlet id IBwindow_;
	
	IBOutlet id IBsheet_;
	
	IBOutlet id IBdrawer_;
	
	IBOutlet id IBtextured_;
	
	id contentView_;
	
	
	NSButton * _closeButton;
	NSButton * _miniaturizeButton;
	NSButton * _zoomButton;
	
	// Data
	
	BOOL animating_;
	
	NSArray * actions_;
	
	unsigned int actionIndex_;
}

- (void) animationAlertSheet:(id) inObject;

- (void) endAnimationAlertSheet:(id) inObject;


- (void) animationDrawerLeft:(id) inObject;

- (void) animationDrawerRight:(id) inObject;

- (void) animationDrawerBottom:(id) inObject;

- (void) endAnimationDrawer:(id) inObject;


- (void) animationMinimize:(id) inObject;

- (void) endAnimationMinimize:(id) inObject;


- (void) animationResize:(id) inObject;

- (void) endAnimationResize:(id) inObject;


- (void) animationShake:(id) inObject;


- (void) animationAlpha:(id) inObject;


- (void) animationAlpha:(id) inObject;


- (void) animationButtons:(id) inObject;


- (void) animationBackgroundColor:(id) inObject;

- (void) endAnimationBackgroundColor:(id) inObject;


- (void) animationBrushedMetal:(id) inObject;

- (void) endAnimationBrushedMetal:(id) inObject;


- (void) animationCustomWindow:(id) inObject;


- (void) runNextAction;

- (IBAction) startAnimation:(id) sender;

- (IBAction) stopAnimation:(id) sender;

@end
